package catenaNegozi;

import java.sql.*;

public class DataSource {

// per usare DB2
    private static String databaseURI = "jdbc:db2:negozi";
// per usare Access o altra sorgente ODBC
//    private static String databaseURI = "jdbc:odbc:homework1";

    static {
        try {
// per usare DB2
            Driver driver = new com.ibm.db2.jcc.DB2Driver();
// per usare Access o altra sorgente ODBC
//            Driver driver = new sun.jdbc.odbc.JdbcOdbcDriver();

            DriverManager.registerDriver(driver);
        } catch (Exception e) {
            System.out.println(e);
        }
    }

    public static Connection getConnection() throws SQLException {
        Connection connection = DriverManager.getConnection(databaseURI);
        return connection;
    }

    public static void close(Connection connection) {
        try {
            if (connection != null) {
                connection.close();
            }
        } catch (SQLException sqle) {
            System.err.println(sqle);
        }
    }

    public static void close(Statement statement) {
        try {
            if (statement != null) {
                statement.close();
            }
        } catch (SQLException sqle) {
            System.err.println(sqle);
        }
    }

    public static void close(ResultSet resultSet) {
        try {
            if (resultSet != null) {
                resultSet.close();
            }
        } catch (SQLException sqle) {
            System.err.println(sqle);
        }
    }

}
