package catenaNegozi;

import java.sql.*;
import java.io.*;
import java.util.*;

class GestoreArticolo extends GestoreTabella{

	 String getNomeTabella(){ return "articolo" ;} ;

     void schermoInserimento(){
            int scelta = -1;
            System.out.println("\n--------------------------------------");
            System.out.println("Inserimento di un nuovo articolo");
            System.out.println("\n--------------------------------------\n");
            System.out.println("1.conoscendo il codice del produttore");
            System.out.println("2.conoscendo il nome del produttore");
            System.out.println("0.Esci");
            System.out.print("\n  Scegli --> ");
            scelta = Console.leggiIntero();
            while (scelta < 0 || scelta > 2){
                System.out.print("Scelta scorretta. Ripeti --> ");
                scelta = Console.leggiIntero();
            }
            if (scelta == 1)
                schermoVerificaProduttore();
            else if (scelta == 2)
                schermoRicercaPerNome();
    }

    private void schermoVerificaProduttore(){
        System.out.print("\nInserisci il Codice         --> ");
        int codMarca=Console.leggiIntero();
        Produttore produttore = null;
        try {
            produttore = Produttore.ricercaPerCodice(codMarca);
            if (produttore == null) {
                System.out.println("\n****** ERRORE: non ci sono produttori con il codice specificato ******");
            } else {
                    schermoInserimentoArticolo(produttore);
            }
        } catch(PersistenceException pe){
           System.err.println(pe);
        }
    }

    private void schermoRicercaPerNome(){
		Produttore produttore = null ;
        System.out.print("\nInserisci il Nome --> ");
        String nome = Console.leggiStringa();
        List listaProduttori = null;
        try {
            listaProduttori = Produttore.ricercaPerNome(nome);
            if (listaProduttori.isEmpty()) {
                System.out.println("\n****** ERRORE: non ci sono produttori con il nome specificato ******");
            } else {
                Iterator it = listaProduttori.iterator();
                int i = 0;
                while (it.hasNext()){
                    produttore = (Produttore)it.next();
                    System.out.println("--------- Produttore n. " + i++);
                    System.out.println("Codice   : " + produttore.getCodMarca());
                    System.out.println("Nome            : " + produttore.getNome());
                    System.out.println("Nazione         : " + produttore.getNazione());
                }
                System.out.println("\nScegli il numero corrispondente al record relativo al produttore:");
                System.out.print("  Scelta --> ");
                int scelta=Console.leggiIntero();
                while(scelta < 0 || scelta >= listaProduttori.size()){
                   System.out.print("Scelta scorretta. Ripeti --> ");
                   scelta = Console.leggiIntero();
                }
                produttore = (Produttore)listaProduttori.get(scelta);                   schermoInserimentoArticolo(produttore);
           }
        } catch (PersistenceException pe) {
            System.err.println(pe);
            schermoIniziale();
        }
    }

    private void schermoInserimentoArticolo(Produttore produttore){
        System.out.println("\n------------- Inserimento Articolo --------------");
        System.out.println("\n------------- Dati del Produttore  --------------");
        System.out.println("Codice fiscale  : " + produttore.getCodMarca());
        System.out.println("Nome            : " + produttore.getNome());
        System.out.println("Nazione           : " + produttore.getNazione());
        System.out.println("--------------------------------------------------");
        Articolo articolo = null ;
        System.out.print("\nInserisci la matricola       -->");
        int matricola = Console.leggiIntero();
           try {
				articolo = Articolo.ricercaArticolo(matricola);
				if (articolo == null) {
					articolo = leggiDatiArticolo(matricola);
					articolo.setProduttore(produttore.getCodMarca());
					articolo.inserisci() ;
				} else {
						GestoreErrori.stampaMessaggio("Matricola esistente");
		   		}
           } catch(PersistenceException pe){
                    GestoreErrori.stampaMessaggio("Inserimento impossibile");
                    System.err.println(pe);
           }

    }

     void schermoModifica(){
		System.out.println("Funzionalita' non disponibile");
    }

     void schermoEliminazione(){
        System.out.println("\n--------------------------------------");
        System.out.println("Cancellazione di un articolo");
        System.out.println("\n--------------------------------------\n");
        System.out.print("Inserisci il codice       ->");
        int matricola = Console.leggiIntero();
        Articolo articolo = null;
        boolean errore=false;
        try {
            articolo = Articolo.ricercaArticolo(matricola);
            if (articolo != null) {
				System.out.println("Articolo da eliminare:");
				System.out.println(articolo);
				System.out.print("Confermi? (S/N)");
				String scelta = Console.leggiStringa();
				if (scelta.toUpperCase().equals("S")){
					articolo.cancella();
					System.out.println("Cancellazione effettuata");
				} else {
					System.out.println("Cancellazione non effettuata");
				};
            } else {
                GestoreErrori.stampaMessaggio("Articolo inesistente");
            }
        } catch (PersistenceException e) {
            GestoreErrori.stampaMessaggio("Cancellazione impossibile");
            System.err.println(e);
        }
    }

    private  Articolo leggiDatiArticolo(int matricola) {
		Articolo articolo = new Articolo();
		articolo.setMatricola(matricola);
		System.out.print("Inserisci la descrizione     -->");
		articolo.setDescrizione(Console.leggiStringa());
		System.out.print("Inserisci il prezzo  -->");
		articolo.setPrezzo(Console.leggiIntero());
		return articolo;
    }

    public static void main(String[] args)
    {
		System.out.println("Test gestione articolo");
		GestoreArticolo gestoreArticolo = new GestoreArticolo();
		gestoreArticolo.schermoIniziale();
	}

}