package catenaNegozi;

import java.sql.*;
import java.io.*;
import java.util.*;

class GestoreProduttore extends GestoreTabella{

	 String getNomeTabella(){ return "Produttore" ;} ;

     void schermoInserimento(){
        System.out.println("\n--------------------------------------");
        System.out.println("Inserimento di un nuovo produttore");
        System.out.println("\n--------------------------------------\n");
        System.out.print("Inserisci il codice       ->");
        int codMarca = Console.leggiIntero();
        Produttore produttore = null;
        boolean errore=false;
        try {
            produttore = Produttore.ricercaPerCodice(codMarca);
            if (produttore == null) {
                produttore = leggiDatiProduttore(codMarca);
                produttore.inserisci();
            } else {
                GestoreErrori.stampaMessaggio("Codice esistente");
            }
        } catch (PersistenceException e) {
            GestoreErrori.stampaMessaggio("Inserimento impossibile");
            System.err.println(e);
        }
    }

     void schermoModifica(){
        System.out.println("\n--------------------------------------");
        System.out.println("Modifica di un produttore");
        System.out.println("\n--------------------------------------\n");
        System.out.print("Inserisci il codice       ->");
        int codMarca = Console.leggiIntero();
        Produttore produttore = null;
        boolean errore=false;
        try {
            produttore = Produttore.ricercaPerCodice(codMarca);
            if (produttore != null) {
				System.out.println("Produttore da modificare:");
				System.out.println(produttore);
                aggiornaDatiProduttore(produttore);
                produttore.aggiorna();
            } else {
                GestoreErrori.stampaMessaggio("Produttore inesistente");
            }
        } catch (PersistenceException e) {
            GestoreErrori.stampaMessaggio("Modifica impossibile");
            System.err.println(e);
        }
    }

     void schermoEliminazione(){
        System.out.println("\n--------------------------------------");
        System.out.println("Cancellazione di un produttore");
        System.out.println("\n--------------------------------------\n");
        System.out.print("Inserisci il codice       ->");
        int codMarca = Console.leggiIntero();
        Produttore produttore = null;
        boolean errore=false;
        try {
            produttore = Produttore.ricercaPerCodice(codMarca);
            if (produttore != null) {
				System.out.println("Produttore da eliminare:");
				System.out.println(produttore);
				System.out.println("Manca il controllo sull'integrita' referenziale");
				System.out.print("Confermi? (S/N)");
				String scelta = Console.leggiStringa();
				if (scelta.toUpperCase().equals("S")){
					produttore.cancella();
					System.out.println("Cancellazione effettuata");
				} else {
					System.out.println("Cancellazione non effettuata");
				};
            } else {
                GestoreErrori.stampaMessaggio("Produttore inesistente");
            }
        } catch (PersistenceException e) {
            GestoreErrori.stampaMessaggio("Cancellazione impossibile");
            System.err.println(e);
        }
    }

    private  Produttore leggiDatiProduttore(int codMarca) {
        Produttore produttore = new Produttore();
        produttore.setCodMarca(codMarca);
        System.out.print("Inserisci il nome         ->");
        String nome = Console.leggiStringa();
        produttore.setNome(nome);
        System.out.print("Inserisci la nazione      ->");
        String nazione = Console.leggiStringa();
        produttore.setNazione(nazione);
        return produttore;
    }

    private  void aggiornaDatiProduttore(Produttore produttore) {
		System.out.println("Produttore da modificare");
		System.out.println("Codice marca (non modificabile): " +
				produttore.getCodMarca() ) ;
		System.out.println("Nome: " + produttore.getNome() ) ;
		System.out.println("Nuovo nome? (Return per mantenere)") ;
        String nome = Console.leggiStringa();
		if (nome.length() > 0){ produttore.setNome(nome);}
		System.out.println("Nazione: " + produttore.getNazione() ) ;
		System.out.println("Nuova nazione? (Return per mantenere)") ;
        String nazione = Console.leggiStringa();
		if (nazione.length() > 0){ produttore.setNazione(nazione);}
    }


    public static void main(String[] args)
    {
		System.out.println("Test gestione produttore");
		GestoreProduttore gestoreProduttore = new GestoreProduttore();
		gestoreProduttore.schermoIniziale();
	}

}